/* 
   directly #included from main.c: convergence profile and statistics 
*/
#ifdef ANCHOR
loop (i,0,anchor.col) {
  anchor.rec[i].var=anchor.rec[i].sum/noint;
  anchor.rec[i].sum=0; }
#endif

      {
        struct ssd_s *ssd;
#  ifdef FREEBC
        double Epot=En.pot*Eunit;
#  else /*# FREEBC */
        double Epot=(En.pot+En.corr/box.V)*Eunit;
#  endif /*#!FREEBC */
#  ifdef RGYR
        double endtoend,Rgyr;
#  endif /*# RGYR */
#  ifdef WIDOM
        double Wid;
#  endif /*# WIDOM */
#  ifdef XSECTION
        double Xsec=0;
#  endif /*# XSECTION */

#  ifdef CLUSTERS
        analyzeclusters(icyc); /* WARNING - stride? */
#  endif /*# CLUSTERS */
#  ifdef XSECTION
        if (xs.freq<0 || (xs.freq>0 && icyc%xs.freq==0)) {
          if (!xs.grid) {
            xs.grid=1;
            WARNING(("xs.freq specified but xs.grid=0: xs.grid:=1.0 set")) }
          StaSet(DT*(xs.freq<0?1:xs.freq),lag.err,2,lag.n);
#    ifdef CLUSTERS
          if (xs.mode&16)
            Xsec=clXsection(xs.A);
          else
#    endif /*# CLUSTERS */
            if (xs.mode&8)
              Xsec=cXsection(cfg[0]);
            else
              Xsec=mXsection(cfg[0]);
          StaSet(DT,lag.err,2,lag.n); }
#  endif  /*# XSECTION  */

        calculateSF();
        if (diff.mode&3) calculatediff(reread.frame,reread.to);

#  ifdef RGYR
        Rgyr=measureplus(&endtoend,rg.end,rg.cp);
#  else /*# RGYR */
        if (lag.M || lag.J)  measureplus();
#  endif /*#!RGYR */

        bounddr(drmax);
        if ((drift&DRIFT_WHEN)==DRIFT_CYCLE) removedrifts(option('v')&64);

        if (GearOrder>2) {
          /*** virtual volume change via <dU/dV> with Gear
               for SHAKE, this is moved to Shake(), module constrd.c */
          measureP(1);
          measureP(2); }
        else if (GearOrder<2 && option('f')) {
          measureP(1);
          /*** virtual volume change via <dU/dV> in the playback mode
               for NVT only: the kinetic part of pressure based on T is used
               NB: measureP(2) accepts twice the kinetic energy and adds the
               kinetic pressure correction */
          if (constrd.mode & RESCALE_CM) En.kin_tr=No.f_tr*T;
          else En.kin=No.f*T;
          measureP(2); }

#  ifdef POLAR
        if (scf.E) measureepspol();
#  endif /*# POLAR */

        ssdistance();

/*** WARNING: watch the former place of this part*/
#  ifdef WIDOM
        if (widom.spreal>=0) Wid=XWidom(widom.spreal,widom.sp);
#    ifdef SLAB
        else Wid=Widom(widom.sp,widom.n,widom.z0,widom.z1,widom.dz,widom.mode);
#    else /*# SLAB */
        else Wid=Widom(widom.sp,widom.n,widom.corr);
#    endif /*#!SLAB */
#  endif /*# WIDOM */

#  ifdef DIHHIST
        StaSet(DT,lag.err,2,lag.n);
        gauchetrans(-2);
#  endif /*# DIHHIST */

#  ifdef HARMONICS
        measureharmonics();
#  endif /*# HARMONICS */

#  ifdef SLAB
        measuredpr(slab.mode);
#  endif /*# SLAB */

#  ifdef BJERRUM
#    include "mainbjerrum.c"
#  endif /*# BJERRUM */


        /*** record convergence profiles ***/
        if (CPbuf) {
          float *CPrec=CPbuf+icyc*NCP;
          int count=0;

          memset(CPrec,0,NCP*sizeof(CPrec[0]));
#  define recordCP(X) { if (count<NCP) CPrec[count++]=(float)(X); }
          /* order of recordCP must match CPinfo in simmeas.c */
          /*column (index in CPrec[] is by 1 less) */
          /*1*/ recordCP(En.tot)
          /*2*/ recordCP(En.T)
          /*3*/ recordCP(Epot/SIE)

          /* columns 4,5 of the convergence profile */
          if (tau.P==0 && tau.sig==0 && tau.rho==0) {
            if (dV==0) {
              if (thermostat==T_NOSE || thermostat==T_NPT) recordCP(En.U*Eunit/SIE)
#  ifdef LOG
              else if (No.first) recordCP(En.pot0*Eunit/SIE)
              else recordCP(En.intra*Eunit/SIE)
#  else /*# LOG */
            else recordCP(rhounit*No.free_mass/box.V)
#  endif /*#!LOG */
              }
            else
              recordCP(En.PdV)
            recordCP(En.P) }
          else {
            if (tau.sig) recordCP(*sigvdWptr)
            else recordCP(rhounit*No.free_mass/box.V);
            if (dV==0) recordCP(En.P)
              else recordCP(En.PdV) }
          /*6*/ recordCP(En.T_in)
          /*7*/ recordCP(En.T_tr)
#  ifdef COULOMB
          /*8*/
            if (Eext.isE<0) {
              if (No.ion) recordCP(En.J[Eext.isE+3])
                else if (Q) recordCP(Q->M[Eext.isE+3])
                else recordCP(En.M[Eext.isE+3]) }
            else {
              if (No.ion) recordCP(sqrt(SQR(En.J)))
              else if (Q) recordCP(sqrt(SQR(Q->M)))
              else recordCP(sqrt(SQR(En.M))) }
#  endif /*# COULOMB */
#  ifdef SHEAR
          /*9*/ recordCP(En.Cv)
#  endif /*# SHEAR */
#  ifdef POLAR
          /*10*/ recordCP(En.self)
#  endif /*# POLAR */
#  ifdef DIHHIST
          /*11*/ recordCP(gauchetrans(dih.cp))
          if (dihcp) fprintf(dihcp,"\n");
#  endif /*# DIHHIST */
#  ifdef RGYR
          /*12*/ recordCP(Rgyr)
          /*13*/ recordCP(endtoend)
#  endif /*# RGYR */
#  ifdef XSECTION
          /*14*/ recordCP(Xsec) /* warning: need not be at the same frequency! */
#  endif /*# XSECTION */
#  ifdef WIDOM
          /*15*/ recordCP(Wid)
#  endif /*# WIDOM */

          /* bug fixed in V2.7f: was En.pot instead of En.U
             bug fixed in V3.4l: cutoff correction was added twice
             bug fixed in V3.4l: use P for NPT */
            En.Hnc=En.Unc+(tau.P?P:En.Pnc)/Punit*box.V;
          En.H=En.U+(tau.P?P:En.P)/Punit*box.V;

#  if (PRESSURETENSOR&PT_ANY) == PT_ANY
          En.Hz=En.U+(tau.P?P:En.Ptens[2])/Punit*box.V;
#  endif /*# (PRESSURETENSOR&PT_ANY) == PT_ANY */

          /* variables recorded in SIMNAME.cpi (incl. distances) */
          looplist (ssd,ssd0) {
            if (ssd->indx[0]==-1) recordCP(*ssd->u.q*Eunit/SIE)
            else if (ssd->indx[0]==-2) recordCP(*ssd->u.q*massunit*lengthunit/Sqr(timeunit)/chargeunit)
            else if (ssd->indx[0]==-9) recordCP(*ssd->u.q)
            else recordCP(ssd->u.dist); } }

        StaSet(DT,lag.err,2,lag.n);
        StaAdd("Tkin",En.T); issta=1;
        StaAdd("Tin",En.T_in);
        StaAdd("Ttr",En.T_tr);
#  ifdef LOG
        StaAddE("Ein",En.intra*Eunit);
        if (No.first) StaAddE(string("Epot0 (<%d)",No.first),En.pot0*Eunit);
#  endif /*# LOG */
        StaSet(DT,2,2,0);
        StaAdd("virial",En.vir);
#  ifdef ECC
        StaAdd("ECC Pvir [Pa]",En.ECC_Pvir); /* "virial pressure" via Uel, former P (new in V3.4a) */
        StaAdd("ECC Pnel [Pa]",((En.kin*2*No.Pkinq+En.ECC_virnel)/DIM+En.corr/box.V)/box.V*Punit);
        StaSet(DT,lag.err,2,lag.n);
        StaAdd("ECC P [Pa]",En.P); /* ECC pressure (new in V3.4a) */
        StaAdd("ECC Pscaled [Pa]",En.ECC_Pscaled); /* conventional pressure (ef=const, new in V3.4a) */
        StaAddE("ECC Uscaled",Epot-En.ECC_U3*Eunit);
        StaAddE("ECC Epot",Epot);
#  else /*# ECC */
        StaSet(DT,lag.err,2,lag.n);
        StaAddE("Epot",Epot);
        StaSet(DT,lag.err,2,lag.n);
        StaAdd("P [Pa]",En.P);
#  endif /*#!ECC */
        if (dV)
          StaAdd("P-PdV [Pa]",En.P-En.PdV);
        if (tau.P) {
          StaAdd("V",box.V);
          if (rescale&RESCALE_PT) {
            if (rescale&RESCALE_X) StaAdd("Lx",box.L[0]);
            if (rescale&RESCALE_Y) StaAdd("Ly",box.L[1]);
            if (rescale&RESCALE_Z) StaAdd("Lz",box.L[2]); }
          StaSet(DT,2,2,0);
          StaAddE("Ecorr",En.corr/box.V*Eunit);
          StaAdd("Pcorr [Pa]",En.corr/Sqr(box.V)*Punit); }
        StaSet(DT,lag.err,2,lag.n);
        if (tau.sig)
          StaAdd("sigvdW",*sigvdWptr);

#  ifdef SLAB
        if (wall.n) {
          if (abs(wall.n)&1) StaAdd("Pwall[0] [Pa]",En.Pwall[0]);
          if (abs(wall.n)&2) StaAdd("Pwall[1] [Pa]",En.Pwall[1]); }
#  endif /*# SLAB */

#  if PRESSURETENSOR&PT_OFF
        if (lag.Pt) {
          double tr;

          StaSet(DT,lag.Pt,2,0);
          StaAdd("Ptyz [Pa]",En.Ptens[3]);
          StaAdd("Ptzx [Pa]",En.Ptens[4]);
          StaAdd("Ptxy [Pa]",En.Ptens[5]);
          /* Daivis, Evans: JCP 100 541 (1994) */
          tr=(En.Ptens[0]+En.Ptens[1]+En.Ptens[2])/3;
          StaAdd("Ptxx-tr [Pa]",En.Ptens[0]-tr);
          StaAdd("Ptyy-tr [Pa]",En.Ptens[1]-tr);
          StaAdd("Ptzz-tr [Pa]",En.Ptens[2]-tr); }
#  endif /*# PRESSURETENSOR&PT_OFF */

        StaSet(DT,lag.err,2,lag.n);
        StaAdd("Etot",En.tot);
        StaAddE("internal energy",En.U*Eunit);
        StaAddE("enthalpy",En.H*Eunit);
        if ((thermostat==T_BERENDSEN || thermostat>=T_ANDERSEN) && tau.E==0)
          LRAdd("Etot",1,t,En.tot);
        if (lastEtot<2.999e33) {
          lastEtot -= En.tot;
          StaSet(DT,2,2,0);
          StaAdd("|dEtot|",fabs(lastEtot));
          StaAdd("dEtot^2",lastEtot*lastEtot); }
#  if (PRESSURETENSOR&PT_ANY) == PT_ANY
        StaSet(DT,lag.err,2,lag.n);
        StaAdd("P(Ptens) [Pa]",En.trPt=SUM(En.Ptens)/3+En.corr/(box.V*box.V)*Punit);
        StaSet(DT,2,2,0);
        StaAdd("P(Ptens)-P [Pa]",En.trPt-En.P);
        if (dV)
          StaAdd("P(Ptens)-PdV [Pa]",En.trPt-En.PdV);
#  endif /*# (PRESSURETENSOR&PT_ANY) == PT_ANY */

        StaSet(DT,lag.err,2,lag.n);
        looplist (ssd,ssd0) if (ssd->stat) {
          if (ssd->indx[0]==-1) StaAddE(ssd->name,*ssd->u.q*Eunit);
          else if (ssd->indx[0]==-2) StaAdd(ssd->name,*ssd->u.q*massunit*lengthunit/Sqr(timeunit)/chargeunit);
          else if (ssd->indx[0]==-9) StaAdd(ssd->name,*ssd->u.q);
          else StaAdd(ssd->name,ssd->u.dist); }
      } /* convergence profile and statistics */
